Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 4590)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 4591)
@@ -681,25 +715,21 @@
 
           CASE ( 'r_a*' )
-             IF ( ALLOCATED( r_a_av ) ) THEN 
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+             IF ( ALLOCATED( r_a_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         r_a_av(j,i) = r_a_av(j,i) +                           &
-                                         surf_lsm_h%r_a(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         r_a_av(j,i) = r_a_av(j,i) +                           &
-                                         surf_usm_h%frac(m,ind_veg_wall)  *    &
-                                         surf_usm_h%r_a(m)       +             & 
-                                         surf_usm_h%frac(m,ind_pav_green) *    &
-                                         surf_usm_h%r_a_green(m) +             & 
-                                         surf_usm_h%frac(m,ind_wat_win)   *    &
-                                         surf_usm_h%r_a_window(m)
+                         r_a_av(j,i) = r_a_av(j,i) + surf_lsm_h%r_a(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         r_a_av(j,i) = r_a_av(j,i) + surf_usm_h%frac(m,ind_veg_wall)  *            &
+                                                     surf_usm_h%r_a(m)       +                     &
+                                                     surf_usm_h%frac(m,ind_pav_green) *            &
+                                                     surf_usm_h%r_a_green(m) +                     &
+                                                     surf_usm_h%frac(m,ind_wat_win)   *            &
+                                                     surf_usm_h%r_a_window(m)
                       ENDIF
                    ENDDO
@@ -708,5 +738,5 @@
 
           CASE ( 's' )
-             IF ( ALLOCATED( s_av ) ) THEN 
+             IF ( ALLOCATED( s_av ) ) THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -721,29 +751,22 @@
 !
 !--          In case of default surfaces, clean-up flux by density.
-!--          In case of land- and urban-surfaces, convert fluxes into
-!--          dynamic units.
-             IF ( ALLOCATED( shf_av ) ) THEN 
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=            &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+!--          In case of land- and urban-surfaces, convert fluxes into dynamic units.
+             IF ( ALLOCATED( shf_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_def )  THEN
                          m = surf_def_h(0)%end_index(j,i)
-                         shf_av(j,i) = shf_av(j,i) +                           &
-                                         surf_def_h(0)%shf(m)  *               &
-                                         heatflux_output_conversion(nzb)
+                         shf_av(j,i) = shf_av(j,i) + surf_def_h(0)%shf(m)  *                       &
+                                       heatflux_output_conversion(nzb)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         shf_av(j,i) = shf_av(j,i) +                           &
-                                         surf_lsm_h%shf(m) * c_p
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         shf_av(j,i) = shf_av(j,i) +                           &
-                                         surf_usm_h%shf(m) * c_p
+                         shf_av(j,i) = shf_av(j,i) + surf_lsm_h%shf(m) * c_p
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         shf_av(j,i) = shf_av(j,i) + surf_usm_h%shf(m) * c_p
                       ENDIF
                    ENDDO
@@ -762,26 +785,20 @@
 
           CASE ( 'ssws*' )
-             IF ( ALLOCATED( ssws_av ) ) THEN 
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=            &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+             IF ( ALLOCATED( ssws_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_def )  THEN
                          m = surf_def_h(0)%end_index(j,i)
-                         ssws_av(j,i) = ssws_av(j,i) +                         &
-                                         surf_def_h(0)%ssws(m)
+                         ssws_av(j,i) = ssws_av(j,i) + surf_def_h(0)%ssws(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         ssws_av(j,i) = ssws_av(j,i) +                         &
-                                         surf_lsm_h%ssws(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         ssws_av(j,i) = ssws_av(j,i) +                         &
-                                         surf_usm_h%ssws(m)
+                         ssws_av(j,i) = ssws_av(j,i) + surf_lsm_h%ssws(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         ssws_av(j,i) = ssws_av(j,i) + surf_usm_h%ssws(m)
                       ENDIF
                    ENDDO
@@ -790,26 +807,20 @@
 
           CASE ( 't*' )
-             IF ( ALLOCATED( ts_av ) ) THEN 
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=            &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+             IF ( ALLOCATED( ts_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_def )  THEN
                          m = surf_def_h(0)%end_index(j,i)
-                         ts_av(j,i) = ts_av(j,i) +                             &
-                                         surf_def_h(0)%ts(m)
+                         ts_av(j,i) = ts_av(j,i) + surf_def_h(0)%ts(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         ts_av(j,i) = ts_av(j,i) +                             &
-                                         surf_lsm_h%ts(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         ts_av(j,i) = ts_av(j,i) +                             &
-                                         surf_usm_h%ts(m)
+                         ts_av(j,i) = ts_av(j,i) + surf_lsm_h%ts(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         ts_av(j,i) = ts_av(j,i) + surf_usm_h%ts(m)
                       ENDIF
                    ENDDO
@@ -818,26 +829,20 @@
 
           CASE ( 'tsurf*' )
-             IF ( ALLOCATED( tsurf_av ) ) THEN    
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=            &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+             IF ( ALLOCATED( tsurf_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_def )  THEN
                          m = surf_def_h(0)%end_index(j,i)
-                         tsurf_av(j,i) = tsurf_av(j,i) +                       &
-                                         surf_def_h(0)%pt_surface(m)
+                         tsurf_av(j,i) = tsurf_av(j,i) + surf_def_h(0)%pt_surface(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         tsurf_av(j,i) = tsurf_av(j,i) +                       &
-                                         surf_lsm_h%pt_surface(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         tsurf_av(j,i) = tsurf_av(j,i) +                       &
-                                         surf_usm_h%pt_surface(m)
+                         tsurf_av(j,i) = tsurf_av(j,i) + surf_lsm_h%pt_surface(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         tsurf_av(j,i) = tsurf_av(j,i) + surf_usm_h%pt_surface(m)
                       ENDIF
                    ENDDO
@@ -857,26 +862,20 @@
 
           CASE ( 'us*' )
-             IF ( ALLOCATED( us_av ) ) THEN   
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=            &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+             IF ( ALLOCATED( us_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_def )  THEN
                          m = surf_def_h(0)%end_index(j,i)
-                         us_av(j,i) = us_av(j,i) +                             &
-                                         surf_def_h(0)%us(m)
+                         us_av(j,i) = us_av(j,i) + surf_def_h(0)%us(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         us_av(j,i) = us_av(j,i) +                             &
-                                         surf_lsm_h%us(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         us_av(j,i) = us_av(j,i) +                             &
-                                         surf_usm_h%us(m)
+                         us_av(j,i) = us_av(j,i) + surf_lsm_h%us(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         us_av(j,i) = us_av(j,i) + surf_usm_h%us(m)
                       ENDIF
                    ENDDO
@@ -885,5 +884,5 @@
 
           CASE ( 'v' )
-             IF ( ALLOCATED( v_av ) ) THEN 
+             IF ( ALLOCATED( v_av ) ) THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -896,5 +895,5 @@
 
           CASE ( 'thetav' )
-             IF ( ALLOCATED( vpt_av ) ) THEN 
+             IF ( ALLOCATED( vpt_av ) ) THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -907,5 +906,5 @@
 
           CASE ( 'w' )
-             IF ( ALLOCATED( w_av ) ) THEN 
+             IF ( ALLOCATED( w_av ) ) THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -918,82 +917,64 @@
 
           CASE ( 'z0*' )
-             IF ( ALLOCATED( z0_av ) ) THEN 
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=            &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+             IF ( ALLOCATED( z0_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_def )  THEN
                          m = surf_def_h(0)%end_index(j,i)
-                         z0_av(j,i) = z0_av(j,i) +                             &
-                                         surf_def_h(0)%z0(m)
+                         z0_av(j,i) = z0_av(j,i) + surf_def_h(0)%z0(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         z0_av(j,i) = z0_av(j,i) +                             &
-                                         surf_lsm_h%z0(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         z0_av(j,i) = z0_av(j,i) +                             &
-                                         surf_usm_h%z0(m)
-                      ENDIF
-                   ENDDO
-                ENDDO   
+                         z0_av(j,i) = z0_av(j,i) + surf_lsm_h%z0(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         z0_av(j,i) = z0_av(j,i) + surf_usm_h%z0(m)
+                      ENDIF
+                   ENDDO
+                ENDDO
              ENDIF
 
           CASE ( 'z0h*' )
-             IF ( ALLOCATED( z0h_av ) ) THEN 
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=            &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+             IF ( ALLOCATED( z0h_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_def )  THEN
                          m = surf_def_h(0)%end_index(j,i)
-                         z0h_av(j,i) = z0h_av(j,i) +                           &
-                                         surf_def_h(0)%z0h(m)
+                         z0h_av(j,i) = z0h_av(j,i) + surf_def_h(0)%z0h(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         z0h_av(j,i) = z0h_av(j,i) +                           &
-                                         surf_lsm_h%z0h(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         z0h_av(j,i) = z0h_av(j,i) +                           &
-                                         surf_usm_h%z0h(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
-   
+                         z0h_av(j,i) = z0h_av(j,i) + surf_lsm_h%z0h(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         z0h_av(j,i) = z0h_av(j,i) + surf_usm_h%z0h(m)
+                      ENDIF
+                   ENDDO
+                ENDDO
+             ENDIF
+
           CASE ( 'z0q*' )
-             IF ( ALLOCATED( z0q_av ) ) THEN 
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <=            &
-                                  surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <=               &
-                                  surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <=               &
-                                  surf_usm_h%end_index(j,i)
+             IF ( ALLOCATED( z0q_av ) ) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
+                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
+                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
 
                       IF ( match_def )  THEN
                          m = surf_def_h(0)%end_index(j,i)
-                         z0q_av(j,i) = z0q_av(j,i) +                           &
-                                         surf_def_h(0)%z0q(m)
+                         z0q_av(j,i) = z0q_av(j,i) + surf_def_h(0)%z0q(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
                          m = surf_lsm_h%end_index(j,i)
-                         z0q_av(j,i) = z0q_av(j,i) +                           &
-                                         surf_lsm_h%z0q(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         z0q_av(j,i) = z0q_av(j,i) +                           &
-                                         surf_usm_h%z0q(m)
+                         z0q_av(j,i) = z0q_av(j,i) + surf_lsm_h%z0q(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h%end_index(j,i)
+                         z0q_av(j,i) = z0q_av(j,i) + surf_usm_h%z0q(m)
                       ENDIF
                    ENDDO
@@ -1003,7 +984,7 @@
           CASE DEFAULT
 
-!--          In case of urban surface variables it should be always checked
-!--          if respective arrays are allocated, at least in case of a restart
-!--          run, as averaged usm arrays are not read from file at the moment.
+!--          In case of urban surface variables it should be always checked if respective arrays are
+!--          allocated, at least in case of a restart run, as averaged usm arrays are not read from
+!--          file at the moment.
              IF ( urban_surface )  THEN
                 CALL usm_3d_data_averaging( 'allocate', trimvar )
